// Code generated by go-swagger; DO NOT EDIT.

package networks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// VMNetworkCreateHandlerFunc turns a function with the right signature into a vm network create handler
type VMNetworkCreateHandlerFunc func(VMNetworkCreateParams) middleware.Responder

// Handle executing the request and returning a response
func (fn VMNetworkCreateHandlerFunc) Handle(params VMNetworkCreateParams) middleware.Responder {
	return fn(params)
}

// VMNetworkCreateHandler interface for that can handle valid vm network create params
type VMNetworkCreateHandler interface {
	Handle(VMNetworkCreateParams) middleware.Responder
}

// NewVMNetworkCreate creates a new http.Handler for the vm network create operation
func NewVMNetworkCreate(ctx *middleware.Context, handler VMNetworkCreateHandler) *VMNetworkCreate {
	return &VMNetworkCreate{Context: ctx, Handler: handler}
}

/*VMNetworkCreate swagger:route POST /api/networks Networks vmNetworkCreate

Create network

*/
type VMNetworkCreate struct {
	Context *middleware.Context
	Handler VMNetworkCreateHandler
}

func (o *VMNetworkCreate) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewVMNetworkCreateParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
